VERSION 1.0 CLASS
BEGIN
  MultiUse = 0   'False
END
Attribute VB_Name = "UncConversion"
Attribute VB_Creatable = True
Attribute VB_Exposed = True
' ------------------------------------------------------
' UNCConvt.CLS -- Copyright (c) Slightly Tilted Software
' By:       L.J. Johnson
' Date:     10-13-1996
' Comments: Class module with one exposed method,
'           GetUNCName.
' ------------------------------------------------------
Option Explicit

Private Const NO_ERROR = 0&
Private Const ERROR_MORE_DATA = 234&

Private Declare Sub CopyMem _
    Lib "kernel32" Alias "RtlMoveMemory" _
    (lpTo As Any, _
     lpFrom As Any, _
     ByVal plngCount As Long)
Private Declare Function lstrlen _
    Lib "kernel32" Alias "lstrlenA" _
    (ByVal sText As Any) As Long
Private Declare Function WNetOpenEnum _
   Lib "mpr.dll" Alias "WNetOpenEnumA" _
   (ByVal dwScope As Long, _
    ByVal dwType As Long, _
    ByVal dwUsage As Long, _
    lpNetResource As Any, _
    lphEnum As Long) As Long
Private Declare Function WNetEnumResource _
   Lib "mpr.dll" Alias "WNetEnumResourceA" _
   (ByVal hEnum As Long, _
    lpcCount As Long, _
    lpBuffer As Any, _
    lpBufferSize As Long) As Long
Private Declare Function WNetCloseEnum _
   Lib "mpr.dll" _
   (ByVal hEnum As Long) As Long

Private Const RESOURCE_CONNECTED = &H1&
Private Const RESOURCETYPE_ANY = &H0&
Private Const RESOURCEUSAGE_ALL = &H0&
Private Const RESOURCE_ENUM_ALL = &HFFFF&

Private Type NETRESOURCE
    dwScope          As Long
    dwType           As Long
    dwDisplayType    As Long
    dwUsage          As Long
    pLocalName       As Long
    pRemoteName      As Long
    pComment         As Long
    pProvider        As Long
End Type

Private Type NETRESOURCE_REAL
    dwScope          As Long
    dwType           As Long
    dwDisplayType    As Long
    dwUsage          As Long
    sLocalName       As String
    sRemoteName      As String
    sComment         As String
    sProvider        As String
End Type

' ------------------------------------------------
'
' ------------------------------------------------
Public Function GetUNCName(xstrPassed As String) As String
   Dim plngRtn          As Long
   Dim hEnum            As Long
   Dim plngCount        As Long
   Dim plngLoop         As Long
   Dim plngLen          As Long
   Dim plngBufSize      As Long
   Dim patypNetApi()    As NETRESOURCE
   Dim patypNet()       As NETRESOURCE_REAL
   Dim pabytBuf()       As Byte
   Dim pstrStart        As String
   Dim pstrRemaining    As String
   Dim pbolRtnUnc       As Boolean
   Dim plngPos          As Long
   
   
   On Error Resume Next

   ' ---------------------------------------------
   ' Divide the passed passed string into 2
   '     strings (Drive+colon, and remaining)
   ' ---------------------------------------------
   pstrStart = Left$(xstrPassed, 2)
   pstrRemaining = Mid$(xstrPassed, 3)
   
   
   ' ---------------------------------------------
   ' Open the enumeration handle
   ' ---------------------------------------------
   If WNetOpenEnum(RESOURCE_CONNECTED, _
                   RESOURCETYPE_ANY, _
                   RESOURCEUSAGE_ALL, _
                   ByVal 0&, _
                   hEnum) = NO_ERROR Then
                   
      plngCount = RESOURCE_ENUM_ALL
      
      ReDim pabytBuf(0 To &H10000) As Byte
      plngBufSize = UBound(pabytBuf)
      
      ' ------------------------------------------
      ' Enumerate the network resources
      ' ------------------------------------------
      plngRtn = WNetEnumResource(hEnum, plngCount, _
                                 pabytBuf(0), plngBufSize)
      
      ' ------------------------------------------
      ' If the buffer for enumeration wasn't big
      '     enough, increase the size
      ' ------------------------------------------
      If plngRtn = ERROR_MORE_DATA Then
          plngCount = RESOURCE_ENUM_ALL
          ReDim pabytBuf(0 To plngBufSize) As Byte
          plngRtn = WNetEnumResource(hEnum, plngCount, _
                                     pabytBuf(0), plngBufSize)
      End If
      
      ' ------------------------------------------
      ' If successful, then parse out the
      '     individual resources
      ' ------------------------------------------
      If plngRtn = NO_ERROR Then
         If plngCount > 0 Then
            ReDim patypNetApi(0 To plngCount - 1) As NETRESOURCE
            ReDim patypNet(0 To plngCount - 1) As NETRESOURCE_REAL
            CopyMem patypNetApi(0), pabytBuf(0), Len(patypNetApi(0)) * plngCount
            
            ' ------------------------------------
            ' For each of the returned resources...
            ' ------------------------------------
            For plngLoop = 0 To plngCount - 1
               
               ' ---------------------------------
               ' Get the local (pathed) name
               ' ---------------------------------
               If patypNetApi(plngLoop).pLocalName Then
                  plngLen = lstrlen(patypNetApi(plngLoop).pLocalName)
                  patypNet(plngLoop).sLocalName = Space$(plngLen)
                  CopyMem ByVal patypNet(plngLoop).sLocalName, ByVal patypNetApi(plngLoop).pLocalName, plngLen
               End If
               
               ' ---------------------------------
               ' Get the remote (UNC) name
               ' ---------------------------------
               If patypNetApi(plngLoop).pRemoteName Then
                  plngLen = lstrlen(patypNetApi(plngLoop).pRemoteName)
                  patypNet(plngLoop).sRemoteName = Space$(plngLen)
                  CopyMem ByVal patypNet(plngLoop).sRemoteName, ByVal patypNetApi(plngLoop).pRemoteName, plngLen
               End If
               
               ' ---------------------------------
               ' Compare the local name to the
               '     passed name, if equal, return
               '     that value
               ' ---------------------------------
               If UCase$(patypNet(plngLoop).sLocalName) = UCase$(pstrStart) Then
                  GetUNCName = patypNet(plngLoop).sRemoteName & pstrRemaining
                  Exit For
               End If
            
            Next plngLoop
         
         End If
      
      End If
      
      ' ------------------------------------------
      '
      ' ------------------------------------------
      If hEnum Then
          plngLoop = WNetCloseEnum(hEnum)
      End If
   
   End If

   On Error GoTo 0

End Function
